﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace TCPClient
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        Socket client;
        IPEndPoint ipep;

        private void btnConnect_Click(object sender, EventArgs e)
        {
            client = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            ipep = new IPEndPoint(IPAddress.Parse(txtIPAddress.Text), 8080);
            client.Connect(ipep);
            lblMessage.Text = "Verbunden";
            Refresh();
        }

        private void btnSend_Click(object sender, EventArgs e)
        {
            byte[] data = new byte[1500];
            UTF8Encoding enc = new UTF8Encoding();
            data = enc.GetBytes(txtData.Text);
            client.Send(data);
            lblMessage.Text = "Daten gesendet";
            Refresh();
            client.Receive(data);
            lblMessage.Text = enc.GetString(data);
            Refresh();
            client.Shutdown(SocketShutdown.Both);
            client.Close();
        }

        private void btnSendStream_Click(object sender, EventArgs e)
        {
            NetworkStream ns = new NetworkStream(client);
            StreamWriter sw = new StreamWriter(ns);
            StreamReader sr = new StreamReader(ns);

            sw.WriteLine(txtData.Text);
            sw.Flush();
            lblMessage.Text = sr.ReadLine();

            sr.Close();
            sw.Close();
            ns.Close();
        }


    }
}
