﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace TCPServer
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnStartSocketServer_Click(object sender, EventArgs e)
        {
            Socket server = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            IPEndPoint ipep = new IPEndPoint(IPAddress.Any, 8080);

            server.Bind(ipep);
            server.Listen(5);
            lblMessage.Text = "Server gestartet";
            Refresh();
            Socket s = server.Accept();     // temporärer Socket für Datenaustausch
            lblMessage.Text = "Verbindung hergestellt";
            Refresh();
            byte[] data = new byte[1500];
            s.Receive(data);
            s.Send(data);       // Echo Data
            UTF8Encoding enc = new UTF8Encoding();
            txtDaten.Text = enc.GetString(data);

            s.Shutdown(SocketShutdown.Both);
            s.Close();
            server.Close();
        }

        private void btnStartTCPListener_Click(object sender, EventArgs e)
        {
            TcpListener listener = new TcpListener(IPAddress.Any, 8080);
            listener.Start();
            TcpClient lc = listener.AcceptTcpClient();
            lblMessage.Text = "Verbindung hergestellt";
            Refresh();
            NetworkStream ns = lc.GetStream();
            StreamReader sr = new StreamReader(ns);
            StreamWriter sw = new StreamWriter(ns);
            txtDaten.Text = sr.ReadLine();
            sw.WriteLine(txtDaten.Text);
            sw.Flush();

            sw.Close();
            sr.Close();
            ns.Close();
            lc.Close();
            listener.Stop();
        }

        private void btnStartHTTPListener_Click(object sender, EventArgs e)
        {
            
            HttpListener listener = new HttpListener();
            listener.Prefixes.Add("http://+:8080/");
            listener.Start();
            HttpListenerContext context = listener.GetContext();
            HttpListenerRequest request = context.Request; // Beschreibt den eingehenden HTTP Request
            HttpListenerResponse response = context.Response; // hole respose Web-Seite
            string responseString = "<HTML><BODY>Hello Bulme </BODY></HTML>";
            byte[] data = new byte[1500];
            UTF8Encoding enc = new UTF8Encoding();
            data = enc.GetBytes(responseString);
            response.ContentLength64 = data.Length;
            Stream output = response.OutputStream;
            output.Write(data, 0, data.Length);
            output.Close();
            listener.Stop();
            
        }
        // die index.html datei muss im Ordner D:\xampp\htdocs\index.html sein
        static string rootDirectory = @"D:\xampp\htdocs";
        private static void Process(HttpListenerContext context)
        {
            string filename = context.Request.Url.AbsolutePath;
            Trace.WriteLine(filename);
            filename = filename.Substring(1);
            if (string.IsNullOrEmpty(filename))
                filename = "index.html";
            filename = Path.Combine(rootDirectory, filename);
            Stream input = new FileStream(filename, FileMode.Open);
            byte[] buffer = new byte[1024 * 16];
            int nbytes;
            while ((nbytes = input.Read(buffer, 0, buffer.Length)) > 0)
                context.Response.OutputStream.Write(buffer, 0, nbytes);
            input.Close();
            context.Response.OutputStream.Close();
        }

        private void btnWebServer_Click(object sender, EventArgs e)
        {
            HttpListener server = new HttpListener();
            server.Prefixes.Add("http://+:8080/");
            server.Start();
            for (; ; )
            {
                HttpListenerContext context = server.GetContext(); //The GetContext method blocks while waiting for a request. 
                //new Thread(new Worker(ctx).ProcessRequest).Start();

                Process(context);
            }
        }

    }
}
